import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * This is a white blood cell. This kind of cell has the job to catch 
 * coin and remove them from the blood.
 * 
 * @author Michael Kölling
 * @version 0.1
 */
public class Chicken extends Actor
{
    private int score;
    /**
     * Act: move up and down when cursor keys are pressed.
     */
    public void act() 
    {
        checkKeyPress();
        checkCollision();
        
    }
    
    /**
     * Check whether a keyboard key has been pressed and react if it has.
     */
    private void checkKeyPress()
    {
        if (Greenfoot.isKeyDown("up")) 
        {
            setLocation(getX(), getY()-4);
        }
        
        if (Greenfoot.isKeyDown("down")) 
        {
            setLocation(getX(), getY()+4);
        }
        
        if (Greenfoot.isKeyDown("right")) 
        {
            setLocation(getX()+4, getY());
        }
        
        if (Greenfoot.isKeyDown("left")) 
        {
            setLocation(getX()-4, getY());
        }
    }
    
    private void checkCollision()
    {
       if ( isTouching(Coin.class) )
          {
              removeTouching(Coin.class);
              Greenfoot.playSound("slurp.wav");
              Road road = (Road)getWorld();
              road.addScore(+20); // I must "cast" before I can call the method written in the World class see pg 96 in textbook for details on this topic.
            }
        
       if (isTouching(Rock.class) )
        {
            removeTouching(Rock.class);
            Greenfoot.playSound("Xbox.mp3");
            Road road = (Road)getWorld();
            road.addScore(-100);
            Greenfoot.stop();
        }   
    } 
}
