import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * The bloodstream is the setting for our White Blood Cell scenario. 
 * It's a place where blood cells, bacteria and rockes float around.
 * 
 * @author Michael Kölling
 * @version 0.1
 */
public class Road extends World
{
    private int score;
    private int time;
    private int points;
    /**
     * Constructor: Set up the staring objects.
     */
    public Road()
    {    
        super(780, 360, 1); 
        setPaintOrder(Border.class);
        prepare();
        score = 0;
        showScore();
        time = 2000;
    }

    private void countTime()
    {
        time--;
        showTime();

        if(time == 0)
        {
            showEndMessage();
            Greenfoot.stop();

        }
    }

    private void showTime()
    {
        showText("Time: " + time, 700, 20);

    }

    /**
     * Show end-of-game message on screen
     */
    private void showEndMessage()
    {
        showText("Time is up - you win!", 390, 150);
        showText("Your final score: " + points , 390, 170);
    }

    /**
     * I have created an addScore method and located it in the World class so that I can access this method from all of my Actor classes.
     */

    public void addScore(int points) // I've changed my addScore method to require a parameter of type int.
    {
        score = score + points;
        showScore(); 
    }

    private void showScore()
    {
        showText("Score: " + score, 80, 25); 
    }

    /**
     * Create new floating objects at irregular intervals.
     */
    public void act()
    {
        if (Greenfoot.getRandomNumber(100) < 3)
        {
            addObject(new Coin(), 779, Greenfoot.getRandomNumber(360));
        }
        if (Greenfoot.getRandomNumber(100) < 1)
        {
            addObject(new Clouds(), 779, 6);
        }
        if (Greenfoot.getRandomNumber(100) < 1)
        {
            addObject(new Clouds(), 779, 359);
        }
        if (Greenfoot.getRandomNumber(100) < 1)   
        {
            addObject(new Rock(), 779, Greenfoot.getRandomNumber(360));
        }
        countTime();
    }

    /**
     * Prepare the world for the start of the program. In this case: Create
     * a white blood cell and the lining at the edge of the blood stream.
     */
    private void prepare()
    {
        Chicken chicken = new Chicken();
        addObject(chicken, 135, 179);
        Clouds lining = new Clouds();
        addObject(lining, 126, 1);
        Clouds lining2 = new Clouds();
        addObject(lining2, 342, 5);
        Clouds lining3 = new Clouds();
        addObject(lining3, 589, 2);
        Clouds lining4 = new Clouds();
        addObject(lining4, 695, 5);
        Clouds lining5 = new Clouds();
        addObject(lining5, 114, 359);
        Clouds lining6 = new Clouds();
        Clouds lining7 = new Clouds();
        addObject(lining7, 295, 353);
        Clouds lining8 = new Clouds();
        Clouds lining9 = new Clouds();
        Clouds lining10 = new Clouds();
        addObject(lining10, 480, 358);
        Clouds lining11 = new Clouds();
        addObject(lining11, 596, 359);
        Clouds lining12 = new Clouds();
        addObject(lining12, 740, 354);

        Border border = new Border();
        addObject(border,749,184);
        border.setLocation(749,168);
        border.setLocation(749,177);
        Border border2 = new Border();
        addObject(border2,39,178);
        border.setLocation(759,178);
        removeObject(border);
        removeObject(border2);
        Border border3 = new Border();
        addObject(border3,722,186);
        border3.setLocation(718,180);
        Border border4 = new Border();
        addObject(border4,72,188);
        border4.setLocation(64,180);
        removeObject(border3);
        removeObject(border4);
        Border border5 = new Border();
        addObject(border5,14,184);
        border5.setLocation(12,180);
        Border border6 = new Border();
        addObject(border6,735,187);
    }
}
